/[sysadmin-cookbook]/recepies/lxc/lxc-watchdog.sh
This is repository of my old source code which isn't updated any more. Go to git.rot13.org for current projects!
ViewVC logotype

Diff of /recepies/lxc/lxc-watchdog.sh

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

revision 188 by dpavlin, Tue Mar 16 22:00:20 2010 UTC revision 229 by dpavlin, Sat Sep 11 12:19:12 2010 UTC
# Line 16  Line 16 
16  #  #
17  # based on Tony Risinger post to lxc-users mailing list  # based on Tony Risinger post to lxc-users mailing list
18  # http://www.mail-archive.com/lxc-users@lists.sourceforge.net/msg00074.html  # http://www.mail-archive.com/lxc-users@lists.sourceforge.net/msg00074.html
19    #
20    # Install with:
21    # ln -sf /srv/sysadmin-cookbook/recepies/lxc/lxc-watchdog.sh /etc/init.d/lxc-watchdog
22    # update-rc.d lxc-watchdog defaults
23    
24    
25  which inotifywait >/dev/null || apt-get install inotify-tools  which inotifywait >/dev/null || apt-get install inotify-tools
# Line 33  lxc_exists() { Line 37  lxc_exists() {
37    
38    
39  lxc_rootfs() {  lxc_rootfs() {
40          grep lxc.rootfs "/var/lib/lxc/$1/config" | cut -d= -f2 | sed 's/^ *//'          grep '^ *lxc\.rootfs *=' "/var/lib/lxc/$1/config" | cut -d= -f2 | sed 's/^ *//'
41  }  }
42    
43    
44  lxc_status() {  lxc_status() {
45          lxc-ls -1 | sort -u | xargs -i lxc-info -n {} | sed "s/'//g" | while read name is status ; do          ( find /var/lib/lxc/ -name "config" | cut -d/ -f5 | sort -u | xargs -i lxc-info -n {} | sed "s/'//g" | while read name is status ; do
46                  on_boot="       "                  boot="-"
47                  test -s /var/lib/lxc/$name/on_boot && on_boot="on_boot"                  hostname=`cat $(lxc_rootfs $name)/etc/hostname`
48                  echo "$name $status $on_boot $(lxc_rootfs $name)"                  ip=`grep address $(lxc_rootfs $name)/etc/network/interfaces | sed 's/.*address //'`
49          done                  test -z "$ip" && ip=`grep lxc.network.ipv4 /var/lib/lxc/$name/config | cut -d= -f2`
50                    test -s /var/lib/lxc/$name/on_boot && boot="boot"
51                    echo "$name $status $boot $(lxc_rootfs $name) $ip $hostname"
52            done ) | column -t
53  }  }
54    
55    
# Line 53  cleanup_init_scripts() { Line 60  cleanup_init_scripts() {
60                  $rootfs/etc/rc?.d/*umountfs \                  $rootfs/etc/rc?.d/*umountfs \
61                  $rootfs/etc/rc?.d/*umountroot \                  $rootfs/etc/rc?.d/*umountroot \
62                  $rootfs/etc/rc?.d/*hwclock* \                  $rootfs/etc/rc?.d/*hwclock* \
63                    $rootfs/etc/rc?.d/*udev* \
64          2>/dev/null | xargs -i rm -v {}          2>/dev/null | xargs -i rm -v {}
65    
66            echo $1 > $rootfs/etc/hostname
67  }  }
68    
69    
# Line 64  setup_inittab() { Line 74  setup_inittab() {
74    
75          # let container respond to kill -SIGPWR          # let container respond to kill -SIGPWR
76          inittab=$rootfs/etc/inittab          inittab=$rootfs/etc/inittab
77          if ! grep "$add" ${inittab} >/dev/null ; then          if test -e $inittab && ! grep "$add" ${inittab} >/dev/null ; then
78                  grep -v "$remove" ${inittab} > ${inittab}.new                  grep -v "$remove" ${inittab} > ${inittab}.new
79                  echo $add >> ${inittab}.new                  echo $add >> ${inittab}.new
80                  mv ${inittab}.new ${inittab}                  mv ${inittab}.new ${inittab}
# Line 73  setup_inittab() { Line 83  setup_inittab() {
83  }  }
84    
85    
86    lxc_log() {
87            echo `date +%Y-%m-%dT%H:%M:%S` $*
88    }
89    
90    
91  lxc_kill() {  lxc_kill() {
92          name=$1          name=$1
93          sig=$2          sig=$2
# Line 82  lxc_kill() { Line 97  lxc_kill() {
97                  lxc-info -n $name                  lxc-info -n $name
98                  exit 1                  exit 1
99          fi          fi
100          echo "$name kill $sig $init_pid"          lxc_log "$name kill $sig $init_pid"
101          /bin/kill $sig $init_pid          /bin/kill $sig $init_pid
102  }  }
103    
104  lxc_stop() {  lxc_stop() {
105            lxc_log "$name stop"
106          lxc_kill $name -SIGPWR          lxc_kill $name -SIGPWR
107          lxc-wait -n $name -s STOPPED          lxc-wait -n $name -s STOPPED
108            lxc_log "$name stoped"
109  #       rm -f /var/lib/lxc/${name}/on_boot  #       rm -f /var/lib/lxc/${name}/on_boot
110  }  }
111    
112    
113  lxc_start() {  lxc_start() {
114          name=$1          name=$1
115            rootfs=$(lxc_rootfs $1)
116    
117            if [ ! -e $rootfs ] ; then
118                    echo "ERROR $name rootfs $rootfs not found"
119                    return
120            fi
121    
122          if ! lxc-info -n $name | grep RUNNING ; then          if ! lxc-info -n $name | grep RUNNING ; then
123                  echo "$name start"                  lxc_log "$name start"
124                  lxc-start -n $name -o /tmp/${name}.log -d                  lxc-start -n $name -o /tmp/${name}.log -d
125                  lxc-wait  -n $name -s RUNNING                  lxc-wait  -n $name -s RUNNING
126                  lxc-info  -n $name                  lxc-info  -n $name
# Line 105  lxc_start() { Line 128  lxc_start() {
128          fi          fi
129  }  }
130    
 lxc_log() {  
         echo `date +%Y-%m-%dT%H:%M:%S` $*  
 }  
   
131  lxc_watchdog() {  lxc_watchdog() {
132  name=$1  name=$1
133  rootfs=$(lxc_rootfs $1)  rootfs=$(lxc_rootfs $1)
# Line 152  while true; do Line 171  while true; do
171          inotifywait -qqt 300 ${vps_utmp}          inotifywait -qqt 300 ${vps_utmp}
172  done  done
173    
174  lxc_log "$name exited"  lxc_log "$name watchdog exited"
175    
176  }  }
177    
178    
179    usage() {
180            echo "Usage: $0 {start|stop|restart|status|boot|disable} [name name ... ]" >&2
181            exit 3
182    }
183    
184  command_on_lxc() {  command_on_lxc() {
185  command=$1  command=$1
186  shift  shift
# Line 168  case "$command" in Line 192  case "$command" in
192  start)  start)
193          lxc_exists $1          lxc_exists $1
194          cleanup_init_scripts $1          cleanup_init_scripts $1
195          setup_inittab $1 ::power      "p0::powerfail:/sbin/init 0"          setup_inittab $1 ":respawn:/sbin/getty.*tty1"   "c1:12345:respawn:/sbin/getty 38400 tty1 linux"
196          setup_inittab $1 ::ctrlaltdel "p6::ctrlaltdel:/sbin/init 6"          setup_inittab $1 "::power"                      "p0::powerfail:/sbin/init 0"
197            setup_inittab $1 "::ctrlaltdel"                 "p6::ctrlaltdel:/sbin/init 6"
198          lxc_start $1          lxc_start $1
199          # give container 5 seconds to start more than one process          # give container 5 seconds to start more than one process
200          ( sleep 5 ; nohup $0 watchdog $1 >> /tmp/$1.log 2>/dev/null ) &          ( sleep 5 ; nohup $0 watchdog $1 >> /tmp/$1.log 2>/dev/null ) &
# Line 191  disable) Line 216  disable)
216          echo -n > /var/lib/lxc/$1/on_boot          echo -n > /var/lib/lxc/$1/on_boot
217          ;;          ;;
218  *)  *)
219          echo "Usage: $0 {start|stop|restart|status}" >&2          usage
         exit 3  
220          ;;          ;;
221    
222  esac  esac
# Line 200  esac Line 224  esac
224  }  }
225    
226  command=$1  command=$1
227    test -z "$command" && usage
228  test "$command" = "status" && lxc_status && exit  test "$command" = "status" && lxc_status && exit
229    shift
230    
231  if [ -z "$1" ] ; then  if [ -z "$1" ] ; then
232          ls /var/lib/lxc/*/on_boot | while read path ; do          ls /var/lib/lxc/*/on_boot | while read path ; do
233                  name=`echo $path | cut -d/ -f5`                  name=`echo $path | cut -d/ -f5`
234                  command_on_lxc $command $name                  if [ "$command" != "start" -o "$command" = "start" -a -s $path ] ; then
235                            command_on_lxc $command $name
236                    else
237                            echo "# skip $command $name"
238                    fi
239          done          done
240  else  else
         shift  
241          while [ ! -z "$1" ] ; do          while [ ! -z "$1" ] ; do
242                  command_on_lxc $command $1                  command_on_lxc $command $1
243                  shift                  shift

Legend:
Removed from v.188  
changed lines
  Added in v.229

  ViewVC Help
Powered by ViewVC 1.1.26